/* rcb.f -- translated by f2c (version of 3 February 1990  3:36:42).
    You must link the resulting object file with the libraries:
	-lF77 -lI77 -lm -lc   (in that order)
*/

#include <stdlib.h>
#include "f2c.h"
#include "rcb.h"
#include "rcb2.h"
#include <stdio.h>


void
adderror_tcd(double *ssq, int *noisetp)
{
    /* Local variables */
    static double variance;
    static integer npts;
    extern doublereal noise_(int*,double*,int);
    static integer count;
    static doublereal error;
    int  data_index, dvi;
    
    /* Function Body */
    const_1.sqrt2 = (float)1.414213562373;

    data_index = (datafmt_2.nvar - 1)*4999;
    dvi = datafmt_1.lastcol - 2;
    npts = mandn_2.numpts;
    variance = ssq[dvi] / npts;
    for (count = 0; count < npts; ++count) {
	error = noise_(noisetp, &variance, dvi);
	print_1.data[count + data_index] = __RCBsim_cv_depot[count][dvi] + error;
    }
}
void
adderror_tcd_custom(double *ssq, int *noisetp)
{
    /* Local variables */
    static double variance;
    static integer npts;
    extern doublereal noise_(int*,double*,int);
    static integer count;
    static double error;
    int  data_index, dvi;
    
    /* Function Body */
    const_1.sqrt2 = (float)1.414213562373;

    data_index = (datafmt_2.nvar - 1)*4999;
    dvi = datafmt_1.lastcol - 2;
    npts = mandn_2.numpts;
    variance = ssq[dvi] / npts;
    for (count = 0; count < npts; ++count) {
	error = noise_(noisetp, &variance, dvi);
	print_1.data[count + data_index] = (*_RCB_reverse)(&(__RCBsim_cv_depot[count][dvi]), &error);
    }
}

void
adderror_mcd(double *ssq, int *noisetp)
{
    /* Local variables */
    static double variance[11];
    static integer npts;
    extern doublereal noise_(int*,double*,int);
    static integer count;
    static doublereal error;
    int  kk, index, dvi;
    
    /* Function Body */
    const_1.sqrt2 = (float)1.414213562373;

    dvi = datafmt_1.lastcol - 2;
    npts = mandn_2.numpts;
    for (kk=0 ; kk<=dvi ; kk++)
	variance[kk] = ssq[kk] / npts;
    for (count = 0; count < npts; ++count) {
	for (index=count+4999,kk=0 ; kk<=dvi ; kk++,index+=4999) 
	{
	    error = noise_(noisetp, variance+kk, kk);
	    print_1.data[index] = __RCBsim_cv_depot[count][kk] + error;
	}
    }
}
void
adderror_mcd_custom(double *ssq, int *noisetp)
{
    /* Local variables */
    static double variance[11];
    static integer npts;
    extern doublereal noise_(int*,double*,int);
    static integer count;
    static double error;
    int  kk, index, dvi;
    
    /* Function Body */
    const_1.sqrt2 = (float)1.414213562373;

    dvi = datafmt_1.lastcol - 2;
    npts = mandn_2.numpts;
    for (kk=0 ; kk<=dvi ; kk++)
	variance[kk] = ssq[kk] / npts;
    for (count = 0; count < npts; ++count) {
	for (index=count+4999,kk=0 ; kk<=dvi ; kk++,index+=4999) 
	{
	    error = noise_(noisetp, variance+kk, kk);
	    print_1.data[index] = (*_RCB_reverse)(&(__RCBsim_cv_depot[count][kk]), &error);
	}
    }
}




