/* rcb.f -- translated by f2c (version of 3 February 1990  3:36:42).
    You must link the resulting object file with the libraries:
	-lF77 -lI77 -lm -lc   (in that order)
*/

#include "mbs.h"
#include "f2c.h"
#include "rcb.h"
#include "rcb2.h"

/* Subroutine */ int dosims_(dset, nreal, nint)
integer *dset, *nreal, *nint;
{
    /* Format strings */
    static char fmt_200[] = "(\002DOING SIMULATION #\002,i3)";

    /* System generated locals */
    integer i_1, i_2;
    doublereal d_1;

    /* Builtin functions */
    integer s_wsfe(), do_fio(), e_wsfe(), s_wsle(), e_wsle(), do_lio();
    double sqrt();

    /* Local variables */
    static integer info;
    static doublereal pavg[99];
    extern /* Subroutine */ int adderror_(), modtitle_();
    static doublereal fitparms[99], parmtemp[4999], simparms[494901]	/* 
	    was [99][4999] */;
    static integer i, j, k;
    extern /* Subroutine */ int gpage_();
    static doublereal xdata[4999], ydata[4999], simcv[4999];
    extern /* Subroutine */ int dsort_();
    static integer lconpt, numfit;
    static doublereal perror[99], fitssq;
    static integer uconpt;
    static doublereal simssq[4999];
    extern /* Subroutine */ int caller2_(), xyplot_(), datafit_();
    static doublereal orgdata[4999], ssq;
    extern /* Subroutine */ int setseed_(), siminfo_(), remsims_(), simplot_()
	    ;
    integer i_, j_, k_, total_number_of_points, number_of_dependent_variables;
    int     noise_type, d_idx;
    double  dr, *partial_sum_of_squares;
    double  ucon_margin, lcon_margin, norm;
    
    /* Fortran I/O blocks */
    static cilist io__189 = { 0, 6, 0, fmt_200, 0 };
    static cilist io__192 = { 0, 6, 0, 0, 0 };
    static cilist io__193 = { 0, 6, 0, 0, 0 };
    static cilist io__194 = { 0, 6, 0, 0, 0 };

    setseed_(); 

    fitssq = z2_1.ssqz[*dset + 98];
/* save old ssq for future use */
    numfit = 0;
    if (option2_1.sepopt == 0) {
	mandn_2.numpts = datafile_1.idatapts[datafile_1.numfile];
    } else {
	mandn_2.numpts = datafile_1.idatapts[*dset - 1];
    }
    i_1 = mandn_2.numpts;
    for (j = 1; j <= i_1; ++j) {
	bsnoise_1.fitres[j - 1] = z3_1.fz[z5_1.scount - 1];
/* save residuals for bootstrap error */
	simcv[j - 1] = z3_1.cvz[z5_1.scount - 1];
/* save cv's for simulations */
	orgdata[j - 1] = z3_1.dataz[z5_1.scount - 1];
/* data(*,*) gets clobbered */
	++z5_1.scount;
/* L10: */
    }
    total_number_of_points = mandn_2.numpts;
    number_of_dependent_variables = datafmt_2.nvar - 1;
    if (!(partial_sum_of_squares = (double *)calloc(number_of_dependent_variables, sizeof(double))))
	mbs_alloc_error ("RCBfit (dosims)", "partial sum of squares");
    /*
     *  stow away calculated values, residuals, and data for protection
     */
    for (i_=0 ; i_<total_number_of_points ; i_++)
    {
	__RCBsim_data_depot[i_][0] = print_1.data[i_];
	for (k_=1,j_=0 ; j_<number_of_dependent_variables ; j_++,k_++)
	{
	    __RCBsim_data_depot[i_][k_] = print_1.data[i_ + 4999*k_];
	    __RCBsim_cv_depot[i_][j_]   = __RCB_cv[i_][j_];
	    dr = __RCBsim_res_depot[i_][j_]  = __RCB_res[i_][j_];
	    partial_sum_of_squares[j_] += (dr*dr);
	}
    }
    i_1 = mandn_2.n;
    for (j = 1; j <= i_1; ++j) {
	fitparms[j - 1] = clams_1.x[j - 1];
/* save parm values from fit */
	perror[j - 1] = (float)0.;
	pavg[j - 1] = (float)0.;
/* L20: */
    }
    /* RdB: setseed_(); moved upwards */
    i_1 = simstuff_1.numsim;
    for (i = 1; i <= i_1; ++i) {
	s_wsfe(&io__189);
	do_fio(&c__1, (char *)&i, (ftnlen)sizeof(integer));
	e_wsfe();
	i_2 = mandn_2.n;
	for (j = 1; j <= i_2; ++j) {
	    clams_1.x[j - 1] = fitparms[j - 1];
/* restore guesses to fit parameters */
/* L50: */
	}
/*	adderror_(simcv, &fitssq, &simstuff_1.noisetp);
*/
	noise_type = simstuff_1.noisetp;
	(*_RCB_adderror)(partial_sum_of_squares, &noise_type);

/* add random noise to simcv */
	datafit_(&ssq, &info);
/* fit the simulation */
	if (info < 1 || info > 4) {
	    caller2_(&info, &i);
	    s_wsle(&io__192);
	    e_wsle();
	    s_wsle(&io__193);
	    do_lio(&c__9, &c__1, "** SIMULATION IGNORED **", (ftnlen)24);
	    e_wsle();
	    s_wsle(&io__194);
	    e_wsle();
	    goto L80;
	}
	++numfit;
/* number of successful fits (may not = numsim) */
	if (simstuff_1.simprint >= 1 && option1_1.noption >= 1) {
	    i_2 = mandn_2.numpts;
	    for (k = 1; k <= i_2; ++k) {
		xdata[k - 1] = print_1.data[k - 1];
		ydata[k - 1] = print_1.data[k + datafmt_2.nvar * 4999 - 5000];

/* L60: */
	    }
	    modtitle_(&numfit);
	    gpage_();
	    xyplot_(&mandn_2.numpts, &mandn_2.numpts, xdata, ydata, xdata, 
		    fitting_1.cv);
	}
	simssq[numfit - 1] = ssq;
	i_2 = mandn_2.n;
	for (j = 0; j < i_2; ++j) {
	    simparms[j + (numfit-1) * 99] = clams_1.x[j];
/* Computing 2nd power */
	    d_1 = clams_1.x[j] - fitparms[j];
	    perror[j] += d_1 * d_1;
	    pavg[j] += clams_1.x[j];
/* L70: */
	}
L80:
	z2_1.ssqz[*dset + 98] = fitssq;
	i_2 = mandn_2.numpts;
	d_idx = (datafmt_2.nvar-1)*4999;
	for (j = 0; j < i_2; ++j) {
	    extra_1.f[j] = bsnoise_1.fitres[j];
	    z3_1.cvz[j] = simcv[j];
	    print_1.data[j + d_idx] = orgdata[j];
/* L85: */
	}
	/*
	 *  restore calculated values, residuals, and data from protected depots
	 */
	for (i_=0 ; i_<total_number_of_points ; i_++)
	{
	    print_1.data[i_] = __RCBsim_data_depot[i_][0];
	    for (k_=1,j_=0 ; j_<number_of_dependent_variables ; j_++,k_++)
	    {
		__RCB_cv[i_][j_]  = __RCBsim_cv_depot[i_][j_];
		__RCB_res[i_][j_] = __RCBsim_res_depot[i_][j_];
		print_1.data[i_ + 4999*k_] = __RCBsim_data_depot[i_][k_];
	    }
	}
	/* RdB:	free(partial_sum_of_squares); moved to bottom */

	i_2 = mandn_2.n;
	for (j = 0; j < i_2; ++j) {
	    clams_1.x[j] = fitparms[j];
/* L86: */
	}
/* L40: */
    }
    /*
     *  boundaries of confidence interval
     */
    norm = 0.005*(double)numfit;
    lcon_margin = (100.0 - (double)(option1_1.conint));
    ucon_margin = (100.0 + (double)(option1_1.conint));
    lcon_margin *= norm;
    ucon_margin *= norm;
    lconpt = max(0, (integer)(lcon_margin));
    uconpt = min((integer)(ucon_margin+0.99), numfit);

    if (numfit > 0) {
	i_1 = mandn_2.n;
	for (j = 0; j < i_1; ++j) {
	    perror[j] = sqrt(perror[j] / numfit);
	    pavg[j] /= numfit;
	    i_2 = numfit;
	    for (k = 0; k < i_2; ++k) {
		parmtemp[k] = simparms[j + k * 99];
	    }
	    dsort_(parmtemp, parmtemp, &numfit, &c__1);
	    stats_1.confidl[j] = parmtemp[lconpt - 1];
	    stats_1.confidu[j] = parmtemp[uconpt - 1];
	}
    }
    siminfo_(&numfit, fitparms, &fitssq, simparms, simssq, perror, nreal, 
	    nint, pavg);
    if (option1_1.rsimopt > 0) {
	remsims_(fitparms, &numfit, simparms, perror, pavg);
    } else {
	simparms_1.simcount = numfit;
    }
    if (option1_1.noption < 1) {
	goto L110;
    }
    simplot_(fitparms, &numfit, simparms, perror, pavg);
L110:
    free(partial_sum_of_squares);
    return 0;
} /* dosims_ */

