/* rcb.f -- translated by f2c (version of 3 February 1990  3:36:42).
    You must link the resulting object file with the libraries:
	-lF77 -lI77 -lm -lc   (in that order)
*/

#include "f2c.h"
#include "rcb.h"

/* Subroutine */ int jacknife_(dset, nreal, nint)
integer *dset, *nreal, *nint;
{
    /* Format strings */
    static char fmt_200[] = "(\002REMOVING POINT #\002,i3)";

    /* System generated locals */
    integer i_1, i_2;
    doublereal d_1;

    /* Builtin functions */
    integer s_wsfe(), do_fio(), e_wsfe(), s_wsle(), e_wsle(), do_lio();
    double sqrt();

    /* Local variables */
    static integer info;
    static doublereal pavg[99], jacparms[494901]	/* was [99][4999] */;
    static integer jaccount;
    static doublereal fitparms[99], parmtemp[4999];
    static integer i, j, k;
    static doublereal jaccv[4999];
    extern /* Subroutine */ int dsort_();
    static integer numpt;
    static doublereal jacssq[4999];
    static integer lconpt, numfit;
    static doublereal perror[99], fitssq;
    static integer uconpt;
    extern /* Subroutine */ int caller3_(), jacinfo_(), datafit_();
    static doublereal orgdata[14997]	/* was [4999][3] */, ssq;
    extern /* Subroutine */ int jacplot_();

    /* Fortran I/O blocks */
    static cilist io__212 = { 0, 6, 0, fmt_200, 0 };
    static cilist io__216 = { 0, 6, 0, 0, 0 };
    static cilist io__217 = { 0, 6, 0, 0, 0 };
    static cilist io__218 = { 0, 6, 0, 0, 0 };


    fitssq = z2_1.ssqz[*dset + 98];
/* save old ssq for future use */
    if (option2_1.sepopt == 0) {
	mandn_2.numpts = datafile_1.idatapts[datafile_1.numfile];
    } else {
	mandn_2.numpts = datafile_1.idatapts[*dset - 1];
    }
    i_1 = mandn_2.numpts;
    for (j = 1; j <= i_1; ++j) {
	bsnoise_1.fitres[j - 1] = extra_1.f[j - 1];
/* save residuals for bootstrap error calculation */
	jaccv[j - 1] = fitting_1.cv[j - 1];
/* save cv's for simulations */
	orgdata[j - 1] = print_1.data[j - 1];
/* data(*,*) gets clobbered */
	orgdata[j + 4998] = print_1.data[j + 4998];
	orgdata[j + 9997] = print_1.data[j + 9997];
	orgdata[j + 14996] = print_1.data[j + 14996];
/* L10: */
    }
    i_1 = mandn_2.n;
    for (j = 1; j <= i_1; ++j) {
	fitparms[j - 1] = clams_1.x[j - 1];
/* save parm values from fit */
	perror[j - 1] = (float)0.;
	pavg[j - 1] = (float)0.;
/* L20: */
    }
    --mandn_2.numpts;
/* use one less data point.  restore later */
    numfit = 0;
    i_1 = mandn_2.numpts + 1;
    for (i = 1; i <= i_1; ++i) {
/* numpts+1 because decremented numpts */
	s_wsfe(&io__212);
	do_fio(&c__1, (char *)&i, (ftnlen)sizeof(integer));
	e_wsfe();
	numpt = 0;
	i_2 = mandn_2.numpts + 1;
	for (j = 1; j <= i_2; ++j) {
	    if (j != i) {
		++numpt;
		print_1.data[numpt - 1] = orgdata[j - 1];
		print_1.data[numpt + 4998] = orgdata[j + 4998];
		print_1.data[numpt + 9997] = orgdata[j + 9997];
	    }
/* L45: */
	}
	print_1.data[mandn_2.numpts] = 0.;
/* make sure it worked */
	print_1.data[mandn_2.numpts + 4999] = 0.;
	print_1.data[mandn_2.numpts + 9998] = 0.;
	i_2 = mandn_2.n;
	for (j = 1; j <= i_2; ++j) {
	    clams_1.x[j - 1] = print_1.guess[j - 1];
/* restore guesses to original guesses */
/* L50: */
	}
	datafit_(&ssq, &info);
/* fit the jacknife set */
	if (info < 1 || info > 5) {
	    caller3_(&info, &i);
	    s_wsle(&io__216);
	    e_wsle();
	    s_wsle(&io__217);
	    do_lio(&c__9, &c__1, "** JACKNIFE ATTEMPT IGNORED **", (ftnlen)30);
	    e_wsle();
	    s_wsle(&io__218);
	    e_wsle();
	    goto L80;
	}
	++numfit;
/* number of successful fits (may not = numpts) */
	jacssq[numfit - 1] = ssq;
	i_2 = mandn_2.n;
	for (j = 1; j <= i_2; ++j) {
	    jacparms[j + numfit * 99 - 100] = clams_1.x[j - 1];
/* Computing 2nd power */
	    d_1 = clams_1.x[j - 1] - fitparms[j - 1];
	    perror[j - 1] += d_1 * d_1;
	    pavg[j - 1] += clams_1.x[j - 1];
/* L70: */
	}
L80:
/* L40: */
    ;}
    ++mandn_2.numpts;
    z2_1.ssqz[*dset + 98] = fitssq;
    i_1 = mandn_2.numpts;
    for (j = 1; j <= i_1; ++j) {
	extra_1.f[j - 1] = bsnoise_1.fitres[j - 1];
	fitting_1.cv[j - 1] = jaccv[j - 1];
	print_1.data[j - 1] = orgdata[j - 1];
	print_1.data[j + 4998] = orgdata[j + 4998];
	print_1.data[j + 9997] = orgdata[j + 9997];
	print_1.data[j + 14996] = orgdata[j + 14996];
/* L85: */
    }
    i_1 = mandn_2.n;
    for (j = 1; j <= i_1; ++j) {
	clams_1.x[j - 1] = fitparms[j - 1];
/* L86: */
    }
    lconpt = (integer) (((float)100. - option1_1.conint) / (float)200. * 
	    numfit);
    uconpt = (integer) ((option1_1.conint + (float)100.) / (float)200. * 
	    numfit + (float).99);
    if (numfit > 0) {
	i_1 = mandn_2.n;
	for (j = 1; j <= i_1; ++j) {
	    perror[j - 1] = sqrt(perror[j - 1] / numfit);
	    pavg[j - 1] /= numfit;
	    i_2 = numfit;
	    for (k = 1; k <= i_2; ++k) {
		parmtemp[k - 1] = jacparms[j + k * 99 - 100];
/* L100: */
	    }
	    dsort_(parmtemp, parmtemp, &numfit, &c__1);
	    stats_1.confidl[j - 1] = parmtemp[lconpt - 1];
	    stats_1.confidu[j - 1] = parmtemp[uconpt - 1];
/* L90: */
	}
    }
    jacinfo_(&numfit, fitparms, &fitssq, jacparms, jacssq, perror, nreal, 
	    nint, pavg);
    jaccount = numfit;
    if (option1_1.noption < 1) {
	goto L110;
    }
    jacplot_(fitparms, &numfit, jacparms, perror, pavg);
L110:
    return 0;
} /* jacknife_ */

