/* rcb.f -- translated by f2c (version of 3 February 1990  3:36:42).
    You must link the resulting object file with the libraries:
	-lF77 -lI77 -lm -lc   (in that order)
*/

#include "mbs.h"
#include "f2c.h"
#include "rcb.h"
#include "rcb2.h"

int
outinf_tcd()
{
    int   output_fit_result(FILE*), output_fit_data_tcd(FILE*);
    FILE *outfile;
    
    if (!(outfile = fopen("output", "w")))
	mbs_file_open_error("OUTINF_TCD", "output");
    output_fit_result(outfile);
    output_fit_data_tcd(outfile);
    fclose(outfile);
}
int
outinf_mcd()
{
    int   output_fit_result(FILE*), output_fit_data_mcd();
    FILE *outfile;
    
    if (!(outfile = fopen("output", "w")))
	mbs_file_open_error("OUTINF_TCD", "output");
    output_fit_result(outfile);
    output_fit_data_mcd();
    fclose(outfile);
}

int 
output_fit_result(FILE *outfile)
{
    integer         i_2, idx;
    static integer  nums, i, j, m;

    if (option2_1.sepopt == 0) {
	nums = 1;
    } else {
	nums = datafile_1.numfile;
    }
    for (m=1 ; m<=nums ; ++m) 
    {
	fprintf (outfile, "\ninfo for data set #%d\n", m);
	fprintf (outfile, "--------------------------\n");
	fprintf (outfile, "summary of input variables\n");
	if (option2_1.sepopt)
	    fprintf(outfile, "problem has %d parameters and %d points\n", 
		    mandn_2.n, datafile_1.idatapts[m-1]);
	else
	    fprintf(outfile, "problem has %d parameters and %d points\n", 
		    mandn_2.n, datafile_1.idatapts[datafile_1.numfile]);

	fprintf (outfile, "user defined constants read from tinp\n");
	i_2 = mandn_2.nfix;
	for (i=1,idx=m-1 ; i<=i_2 ; i++,idx+=99)
	    fprintf(outfile, "%7s = %.5e\n", znames_1.rzname + idx*7, z1_1.rzconst[idx]);
	fprintf(outfile,"\n");

	switch (z2_1.infoz[m-1]) 
	{
	  case 0:
	    fprintf(outfile, "improper dnls1 input parameters\n");
	    break;
	  case 1:
	    fprintf(outfile, "relative error in SSQ is at most TOL\n");
	    break;
	  case 2:
	    fprintf(outfile, "relative error in X is at most TOL\n");
	    break;
	  case 3:
	    fprintf(outfile, "relative error in SSQ and X is at most TOL\n");
	    break;
	  case 4:
	    fprintf(outfile, "FVEC is orthogonal to Jacobian\n");
	    break;
	  case 5:
	    fprintf(outfile, "number of calls to USRFUN exceeded\n");
	    break;
	  case 6:
	    fprintf(outfile, "FTOL too small, SSQ reduction impossible\n");
	    break;
	  case 7:
	    fprintf(outfile, "XTOL too small, X reduction impossible\n");
	    break;
	  case 8:
	    fprintf(outfile, "GTOL too small, FVEC orthogonal to Jacobian\n");
	    break;
	}
	fprintf(outfile, "var = ssq/npts = %.5e\n", z2_1.ssqz[m-1]);
	if (mandn_2.numpts != mandn_2.n)
	    fprintf(outfile, "sum of squares = %.5e\tssq/(m-n) = %.5e\n", 
		    z2_1.ssqz[m+98], z2_1.ssqz[m+197]);
	fprintf(outfile, "\n");
	
	fprintf(outfile, " k    name of    guess for  final value of\n");
	fprintf(outfile, "   k-th param   k-th param      k-th param\n");
	i_2 = mandn_2.n;
	for (i=1,idx=m-1 ; i<=i_2 ; i++,idx+=99)
	    fprintf(outfile, "%2d    %7s   %.4e      %.4e\n", i, 
		    znames_1.xzname+idx*7, z1_1.zguess[idx], z1_1.zx[idx]);
    }
}

int
output_fit_data_tcd(FILE *outfile)
{
    void           write_fit_data_tcd(int,integer*,FILE*);
    static integer dcount, i, i_1;

    dcount = 1;
    i_1 = datafile_1.numfile;
    for (i=1 ; i<=i_1; ++i) 
    {
	fprintf (outfile, "\nexp %d\n", i);
	fprintf (outfile, "   i      data value     calculated value        residual\n");
	(*_RCB_write_fit_data)(i, &dcount, outfile);
    }
}
void
write_fit_data_tcd (int index, integer *count, FILE *datafile)
{
    int            i, i_2, j;
    
    i_2 = datafile_1.idatapts[index - 1];
    for (i=1,j=*count-1 ; i <= i_2 ; ++i,++j,++(*count)) 
	fprintf (datafile, "%4d    %12.5e         %12.5e    %12.5e\n",
		 i, z3_1.dataz[j], z3_1.cvz[j], z3_1.fz[j]);
}
void
write_fit_data_tcd_custom (int index, integer *count, FILE *datafile)
{
    static double  prn[3], par[99], residual;
    int            i, i_2, j;
    void           get_parameters(int, double*);
    
    get_parameters(index, par);
    (*_RCB_initialize_parameters)(par);

    i_2 = datafile_1.idatapts[index - 1];
    for (i=1,j=*count-1 ; i <= i_2 ; ++i,++j,++(*count)) 
    {
	(*_RCB_data_converter)(&index, &j, &(z3_1.dataz[j]), &(z3_1.cvz[j]), prn);
	residual = prn[0] - prn[1];
	fprintf (datafile, "%4d    %12.5e         %12.5e    %12.5e\n",
		 i, prn[0], prn[1], residual);
    }
}

int
output_fit_data_mcd()
{
    static char  datafilename[16];
    FILE        *datafile;
    integer      icount;
    int          j, n_exp;
    
    icount = 1;
    n_exp = datafile_1.numfile;
    for (j=1 ; j<=n_exp ; j++)
    {
	sprintf(datafilename, "outdata%d", j);
	if (!(datafile = fopen(datafilename, "w")))
	    mbs_file_open_error("OUTPUT FIT DATA MCD", datafilename);
	(*_RCB_write_fit_data)(j, &icount, datafile);
	fclose (datafile);
    }
}
void
write_fit_data_mcd (int index, integer *count, FILE *datafile)
{
    static double  data[11];
    int            i, ii, kk, npts, numb_dep_var, pt_index;

    numb_dep_var = datafmt_1.lastcol-1;
    npts = wfile_1.npoint[index - 1];
    for (i=1 ; i<=npts ; i++) 
    {
	pt_index = *count-1;
	fprintf (datafile, "%e ", print_1.data[(*count)-1]);
	for (ii=(*count)+4998,kk=0 ; kk<numb_dep_var ; kk++,ii+=4999)
	    fprintf (datafile, "%e %e ", print_1.data[ii], __RCB_cv[pt_index][kk]);
	fprintf (datafile, "\n");
	(*count)++;
    }
}
void
write_fit_data_mcd_custom (int index, integer *count, FILE *datafile)
{
    static double  data[11], prn[3], par[99];
    int            i, j, ii, kk, npts, numb_dep_var, pt_index;
    void           get_parameters(int, double*);

    get_parameters(index, par);
    (*_RCB_initialize_parameters)(par);

    numb_dep_var = datafmt_1.lastcol - 1;
    npts = wfile_1.npoint[index - 1];
    for (i=1 ; i<=npts ; i++) 
    {
	pt_index = *count-1;
	fprintf (datafile, "%e ", print_1.data[(*count)-1]);
	for (ii=(*count)+4998,j=1,kk=0 ; kk<numb_dep_var ; kk++,j++,ii+=4999)
	{
	    (*_RCB_data_converter)(&index, &j, &(print_1.data[ii]), &(__RCB_cv[pt_index][kk]), prn);
	    fprintf (datafile, "%e %e ", prn[0], prn[1]);
	}
	fprintf (datafile, "\n");
	(*count)++;
    }
}

static int tru_index[99];

void
get_parameters(int kk, double *par)
{
    int      i, j, ifree, ifixed, nfree, npar, d_idx, nexp;
    int      idx, keep;
    void     map_indices();
    
    map_indices();

    nexp   = wfile_.nfile;
    d_idx  = kk - 1;
    
    nfree  = mandn_1.n;
    npar   = nfree + mandn_1.nfix;
    ifree = ifixed = i = j = 0;
    if (mandn_1.ifree[i])  idx = mandn_1.ifree[ifree];
    else                   idx = mandn_1.ifixed[ifixed];
    while (i < npar)
    {
	++j;
	keep = scan_jsame(idx);
	if (keep)
	{
	    i++;
	    if (ifree < nfree) 
	    {  
		par[tru_index[idx]] = clams_1.x[ifree];        
		ifree++;   
	    }  
	    else               
	    {  
		par[tru_index[idx]] = print_1.rconst[ifixed];
		ifixed++;
	    }
	}
	else
	{
	    i += nexp;
	    if (ifree < nfree) 
	    {  
		par[tru_index[idx]] = clams_1.x[ifree+d_idx];        
		ifree += nexp;   
	    }
	    else               
	    {  
		par[tru_index[idx]] = print_1.rconst[ifixed+d_idx];  
		ifixed += nexp;  
	    }
	}
	if (ifree < nfree)  idx = mandn_1.ifree[ifree];
	else                idx = mandn_1.ifixed[ifixed];
    }
/*
    fprintf (stdout, "%d: ", kk);
    while (j)    fprintf (stdout, "(%d,%e) ", j, par[--j]);
    fprintf (stdout, "\n");
*/
}
int
scan_jsame (index)
{
    int   *jsame = (int*)datafmt_1.jsame;

    while (*jsame)
    {
	if (*jsame++ == index)  return(1);
    }
    return (0);
}
void
map_indices()
{
    int    i, j, ti, nexp, npar;
    
    nexp   = wfile_.nfile;
    npar = mandn_1.n + mandn_1.nfix;
    i = 1;
    ti = 0;
    while (i<=npar)
    {
	tru_index[i] = ti;
	if (!scan_jsame(i++))
	    for (j=1 ; j<nexp ; j++)
		tru_index[i++] = ti;
	ti++;
    }
}
