/*********************************
 *
 *      FUI header comments
 *
 *  FitDataFormat:    TwoColumn  
 *
 *********************************/
#include <math.h>

double   Y, Y0, xp;

void
initialize (double *parameters)
{
/*
    Begin: Synonyms

    Y0                    Initial_Value    y0
    xp                    exponent         xp

    End: Synonyms
*/
    Y0 = parameters[0];
    xp = parameters[1];
}

double
value (double *t)  {  Y = Y0 * exp(-xp*(*t));  return (Y);  }
double 
residual (double *t, double *y)  {  return (*y - Y);  }
