#!/usr/local/bin/perl

srand($ARGV[0]);
$no = 0.2;
$cno = 1.0-$no/2.0;

if ($ARGV[1] == 1) {
    $c1 = 1.0;
    $c2 = 0.02;
    $p  = 0.9;
    $s1 = 10.0;
    $s2 = 100.0;
    for ($t=1.0 ; $t<10.0 ; $t+=1.0) {
	$aux = exp(-$c2*$t);
	$y[1] = $s1 * ($p*(exp(-$c1*$t)-$aux)+$aux);
	$y[2] = $s2 * (1.0-$aux);
	foreach (@y) { $_ *= ($cno+$no*rand); }
	$y[0] = $t;
	foreach (@y) { printf "%e  ", $_; }
	print "\n";
    }
} else {
    $a = 2.0;
    $b = 1.0;
    $c = 0.2;
    $d = 0.1;
    $s = 5.0;
    for ($t=0.01 ; $t<=1.0 ; $t+=0.03) {
	$t2 = $t*$t;
	$t3 = $t*$t2;
	
	$y[1] = $a * exp(-$b*$t);  
	$y[2] = $a + $c*$t;
	$y[3] = $d + $c*$t2;
	$y[4] = $s * ($y[3] + $b*$t3);
	$y[5] = $a + $d*$t + $b*$t2;
	foreach (@y) { $_ *= ($cno+$no*rand); }
	$y[0] = $t;
	foreach (@y) { printf "%e  ", $_; }
	print "\n";
    }
}
