#ifndef  _MBS_PROTOTYPES_H_
#define  _MBS_PROTOTYPES_H_

/*
 * function declarations
 */
sb_complex  *mbs_cube_root(double *coef);

double       mbs_1d_bisec_froot(double(*)(double), double, double, double, double, int*);

double     **mbs_dalloc(int);

void         mbs_binomi(double**, int);

double       mbs_romberg_uniform(double(*)(double), double, double, double, double, int*, int*);
double       mbs_rbs_atom(double(*)(double), double, double);
double       mbs_rbs(double(*)(double), double, double, double, double, int, int*);
double       mbs_romberg(double(*)(double), double, double, double, double, int, int *);

void       **mbs_2D_alloc_array(int, int, int);
void      ***mbs_3D_alloc_array(int, int, int, int);
void     ****mbs_4D_alloc_array(int, int, int, int, int);
void         mbs_2D_free_array(void**);
void         mbs_3D_free_array(void***);
void         mbs_4D_free_array(void****);

void         mbs_alloc_error(char*, char*);
void         mbs_file_open_error(char*, char*);
void         mbs_out_of_range_error (char*, char*, char*, char*, char*);
void         mbs_out_of_range_warning (char*, char*, char*, char*, char*);
void         mbs_dummy_catch(char*);

#endif
