
proc tabForward win_list {
    set i [lsearch -exact $win_list [focus]]
    incr i
    if {$i >= [llength $win_list]} { set i 0 }
    focus [lindex $win_list $i]
}

proc tabBackward win_list {
    set i [lsearch -exact $win_list [focus]]
    incr i -1
    if {$i < 0} { set i [expr [llength $win_list]-1] }
    focus [lindex $win_list $i]
}
proc BSerror {procname message} {
    tk_dialog .errorDialog "" "$procname -- Error:\n$message." "" 0 Ok
}
proc BSwarning {procname message} {
    set response [tk_dialog .warningDialog "" "$procname -- Warning:\n$message." \
        "" 0 Continue Stop]
    if {$response == 0} {
        return 0
    } elseif {$response == 1} {
        return 1
    }
}


