#include "mbs.h"

/*********************************************************************
**
**   MACROS:        
**
**   ROUTINES:      mbs_dalloc
**                 
**********************************************************************/

/*********************************************************************
**
**   Routine Name:  mbs_dalloc
**                  
**   Purpose:       
**
**   Input:         
**   Output:        
**
**   Called By:     
**
**   Written By:    Bernhard Sulzer, LANL
**   Last Edited:   
**
**********************************************************************/

double **
mbs_dalloc(int n)
{
    double   *p1, **p2;
    int       k;
    
    if(!(p2 = (double **)calloc(n+1,sizeof(int))))
	mbs_alloc_error ("MBS DALLOC", "level 1 pointers");
    for (k=0 ; k<=n ; k++)
    {
	if(!(p1 = (double *)calloc(k+1,sizeof(double))))
	    mbs_alloc_error ("MBS DALLOC", "level 0 data");
	p2[k] = p1;
    }
    return(p2);
}


