/* rcb.f -- translated by f2c (version of 3 February 1990  3:36:42).
    You must link the resulting object file with the libraries:
	-lF77 -lI77 -lm -lc   (in that order)
*/

#include "f2c.h"
#include "rcb.h"

/* Subroutine */ int jacinfo_(numfit, fitparms, fitssq, jacparms, jacssq, 
	perror, nreal, nint, pavg)
integer *numfit;
doublereal *fitparms, *fitssq, *jacparms, *jacssq, *perror;
integer *nreal;
integer *nint;
doublereal *pavg;
{
    /* Format strings */
    static char fmt_100[] = "(a7,\002=\002,1pe12.5)";
    static char fmt_120[] = "(\002fit variance (ssq/npts) = \002,1pe12.4)";
    static char fmt_130[] = "(i3,\002    \002,a7,1pe17.5,1pe14.5,\002 +-\002\
,1pe12.5)";
    static char fmt_135[] = "(\002There were \002,i3,\002 successful jacknif\
es\002)";
    static char fmt_140[] = "(\002jac.#\002,i3,\002 variance (ssq/npts) =\
 \002,1pe12.4)";
    static char fmt_200[] = "(\002                     average = \002,1pe12.\
4)";
    static char fmt_150[] = "(\002             \002,a7)";
    static char fmt_160[] = "(\002      \002,i3,\002 -\002,1pe14.5)";
    static char fmt_170[] = "(\002  average -\002,1pe14.5)";
    static char fmt_180[] = "(\002    sigma -\002,1pe14.5)";
    static char fmt_190[] = "(\002orig. fit -\002,1pe14.5)";
    static char fmt_210[] = "(i3,\002% confid. lower - \002,1pe14.5)";
    static char fmt_220[] = "(\002             upper - \002,1pe14.5)";

    /* System generated locals */
    integer i_1, i_2;
    doublereal d_1;

    /* Builtin functions */
    integer s_wsle(), e_wsle(), do_lio(), s_wsfe(), do_fio(), e_wsfe();

    /* Local variables */
    static integer i, j;
    static doublereal jacvar, varavg;

    /* Fortran I/O blocks */
    static cilist io__326 = { 0, 7, 0, 0, 0 };
    static cilist io__327 = { 0, 7, 0, 0, 0 };
    static cilist io__329 = { 0, 7, 0, fmt_100, 0 };
    static cilist io__330 = { 0, 7, 0, 0, 0 };
    static cilist io__331 = { 0, 7, 0, fmt_120, 0 };
    static cilist io__332 = { 0, 7, 0, 0, 0 };
    static cilist io__333 = { 0, 7, 0, 0, 0 };
    static cilist io__334 = { 0, 7, 0, 0, 0 };
    static cilist io__335 = { 0, 7, 0, fmt_130, 0 };
    static cilist io__336 = { 0, 7, 0, 0, 0 };
    static cilist io__337 = { 0, 7, 0, 0, 0 };
    static cilist io__338 = { 0, 7, 0, 0, 0 };
    static cilist io__339 = { 0, 7, 0, fmt_135, 0 };
    static cilist io__340 = { 0, 7, 0, 0, 0 };
    static cilist io__343 = { 0, 7, 0, fmt_140, 0 };
    static cilist io__344 = { 0, 7, 0, fmt_200, 0 };
    static cilist io__345 = { 0, 7, 0, 0, 0 };
    static cilist io__346 = { 0, 7, 0, 0, 0 };
    static cilist io__347 = { 0, 7, 0, 0, 0 };
    static cilist io__348 = { 0, 7, 0, fmt_150, 0 };
    static cilist io__350 = { 0, 7, 0, fmt_160, 0 };
    static cilist io__351 = { 0, 7, 0, fmt_170, 0 };
    static cilist io__352 = { 0, 7, 0, fmt_180, 0 };
    static cilist io__353 = { 0, 7, 0, fmt_190, 0 };
    static cilist io__354 = { 0, 7, 0, fmt_210, 0 };
    static cilist io__355 = { 0, 7, 0, fmt_220, 0 };
    static cilist io__356 = { 0, 7, 0, 0, 0 };


    /* Parameter adjustments */
    --fitparms;
    jacparms -= 100;
    --jacssq;
    --perror;
    --pavg;

    /* Function Body */
    s_wsle(&io__326);
    e_wsle();
    s_wsle(&io__327);
    do_lio(&c__9, &c__1, "user defined constants read from tinp", (ftnlen)37);
    e_wsle();
    i_1 = *nreal;
    for (i = 1; i <= i_1; ++i) {
	s_wsfe(&io__329);
	do_fio(&c__1, names_1.rname + (i - 1) * 7, (ftnlen)7);
	do_fio(&c__1, (char *)&print_1.rconst[i - 1], (ftnlen)sizeof(
		doublereal));
	e_wsfe();
/* L10: */
    }
    s_wsle(&io__330);
    e_wsle();
    s_wsfe(&io__331);
    d_1 = *fitssq / mandn_2.numpts;
    do_fio(&c__1, (char *)&d_1, (ftnlen)sizeof(doublereal));
    e_wsfe();
    s_wsle(&io__332);
    e_wsle();
    s_wsle(&io__333);
    do_lio(&c__9, &c__1, "k     name of     guess for     final value", (ftnlen)43);
    e_wsle();
    s_wsle(&io__334);
    do_lio(&c__9, &c__1, "     k-th param   k-th param    k-th param", (ftnlen)42);
    e_wsle();
    i_1 = mandn_2.n;
    for (i = 1; i <= i_1; ++i) {
	s_wsfe(&io__335);
	do_fio(&c__1, (char *)&i, (ftnlen)sizeof(integer));
	do_fio(&c__1, names_1.xname + (i - 1) * 7, (ftnlen)7);
	do_fio(&c__1, (char *)&print_1.guess[i - 1], (ftnlen)sizeof(
		doublereal));
	do_fio(&c__1, (char *)&fitparms[i], (ftnlen)sizeof(doublereal));
	do_fio(&c__1, (char *)&perror[i], (ftnlen)sizeof(doublereal));
	e_wsfe();
/* L30: */
    }
    s_wsle(&io__336);
    e_wsle();
    s_wsle(&io__337);
    do_lio(&c__9, &c__1, "J A C K N I F E   F I T S", (ftnlen)25);
    e_wsle();
    s_wsle(&io__338);
    e_wsle();
    s_wsfe(&io__339);
    do_fio(&c__1, (char *)&(*numfit), (ftnlen)sizeof(integer));
    e_wsfe();
    s_wsle(&io__340);
    e_wsle();
    varavg = (float)0.;
    i_1 = *numfit;
    for (i = 1; i <= i_1; ++i) {
	jacvar = jacssq[i] / (mandn_2.numpts - 1);
	s_wsfe(&io__343);
	do_fio(&c__1, (char *)&i, (ftnlen)sizeof(integer));
	do_fio(&c__1, (char *)&jacvar, (ftnlen)sizeof(doublereal));
	e_wsfe();
	varavg += jacvar;
/* L40: */
    }
    s_wsfe(&io__344);
    d_1 = varavg / *numfit;
    do_fio(&c__1, (char *)&d_1, (ftnlen)sizeof(doublereal));
    e_wsfe();
    s_wsle(&io__345);
    e_wsle();
    s_wsle(&io__346);
    do_lio(&c__9, &c__1, "jac. #        final value", (ftnlen)25);
    e_wsle();
    s_wsle(&io__347);
    e_wsle();
    i_1 = mandn_2.n;
    for (i = 1; i <= i_1; ++i) {
	s_wsfe(&io__348);
	do_fio(&c__1, names_1.xname + (i - 1) * 7, (ftnlen)7);
	e_wsfe();
	i_2 = *numfit;
	for (j = 1; j <= i_2; ++j) {
	    s_wsfe(&io__350);
	    do_fio(&c__1, (char *)&j, (ftnlen)sizeof(integer));
	    do_fio(&c__1, (char *)&jacparms[i + j * 99], (ftnlen)sizeof(
		    doublereal));
	    e_wsfe();
/* L50: */
	}
	s_wsfe(&io__351);
	do_fio(&c__1, (char *)&pavg[i], (ftnlen)sizeof(doublereal));
	e_wsfe();
	s_wsfe(&io__352);
	do_fio(&c__1, (char *)&perror[i], (ftnlen)sizeof(doublereal));
	e_wsfe();
	s_wsfe(&io__353);
	do_fio(&c__1, (char *)&fitparms[i], (ftnlen)sizeof(doublereal));
	e_wsfe();
	s_wsfe(&io__354);
	do_fio(&c__1, (char *)&option1_1.conint, (ftnlen)sizeof(integer));
	do_fio(&c__1, (char *)&stats_1.confidl[i - 1], (ftnlen)sizeof(
		doublereal));
	e_wsfe();
	s_wsfe(&io__355);
	do_fio(&c__1, (char *)&stats_1.confidu[i - 1], (ftnlen)sizeof(
		doublereal));
	e_wsfe();
	s_wsle(&io__356);
	e_wsle();
/* L60: */
    }
    return 0;
/* L110: */
} /* jacinfo_ */

