/* rcb.f -- translated by f2c (version of 3 February 1990  3:36:42).
   You must link the resulting object file with the libraries:
	-lF77 -lI77 -lm -lc   (in that order)
*/

#include "f2c.h"
#include "rcb.h"
#include <math.h>

doublereal 
noise_(int *noisetp, double *variance, int var_idx)
{
    /* Builtin functions */
    integer s_wsle(), do_lio(), e_wsle();
    double sqrt();

    /* Local variables */
    extern doublereal gaussian_(), bootstrp_(), drand_();

    /* Fortran I/O blocks */
    static cilist io__410 = { 0, 6, 0, 0, 0 };


    switch (*noisetp) {
      case 1:  
	return ((drand_(&c_b502) - 0.5) * 2.0 * sqrt(*variance * 3.0));
	break;
	
      case 2:
	if (*variance != 0.) {
	    return (gaussian_(&c_b502, variance));
	} else {
	    return (0.0);
	}
	break;

      case 3:  
	return (bootstrp_(var_idx));
	break;
	
      default:
	s_wsle(&io__410);
	do_lio(&c__9, &c__1, "noise option invalid.  used uniform dist.", (ftnlen)41);
	e_wsle();
	break;
    }
}


doublereal 
noise_mcd(int *noisetp, double *variance, int var_idx)
{
    /* System generated locals */
    doublereal ret_val;

    /* Builtin functions */
    integer s_wsle(), do_lio(), e_wsle();
    double sqrt();

    /* Local variables */
    extern doublereal gaussian_(), bootstrp_(), drand_();

    /* Fortran I/O blocks */
    static cilist io__410 = { 0, 6, 0, 0, 0 };
    doublereal  random;
    
    switch (*noisetp) {
	case 1:  goto L10;
	case 2:  goto L20;
	case 3:  goto L30;
    }
    s_wsle(&io__410);
    do_lio(&c__9, &c__1, "noise option invalid.  used uniform dist.", (ftnlen)41);
    e_wsle();
L10:
    random = drand_(&c_b502);
    ret_val = (random - (float).5) * (float)2. * sqrt(*variance * (float)3.);
    goto L40;
L20:
    if (*variance != 0.) {
	ret_val = gaussian_(&c_b502, variance);
    } else {
	ret_val = (float)0.;
    }
    goto L40;
L30:
    ret_val = bootstrp_(var_idx);
L40:
    return ret_val;
} /* noise_ */


