/* rcb.f -- translated by f2c (version of 3 February 1990  3:36:42).
    You must link the resulting object file with the libraries:
	-lF77 -lI77 -lm -lc   (in that order)
*/

#include "f2c.h"
#include "rcb.h"
#include "rcb2.h"
#include <math.h>
#include <stdio.h>

int   __RCB_cv_offset, __RCB_dep_var_offset;


/* Subroutine */ int usrfun_(iflag, m2, n2, x, fvec, fjac, ldfjac)
integer *iflag, *m2, *n2;
doublereal *x, *fvec;
doublereal *fjac;
integer *ldfjac;
{
    /* System generated locals */
    integer i_1, i_2;

    /* Local variables */
    extern /* Subroutine */ int paramset_();
    static integer i, j, kk;
    extern /* Subroutine */ int fixcnt_();
    static integer icount, offset;
    extern /* Subroutine */ int fitnum_(), arrange_();

    /* Parameter adjustments */
    --x;
    --fvec;

    /* Function Body */
    if (option2_1.sepopt == 0) {
	arrange_(mandn_1.ifree, mandn_1.ifixed, &option2_1.sepopt);
	fixcnt_(mandn_1.ifree, mandn_1.ifixed, &option2_1.sepopt);
    }
    fitnum_();
    __RCB_cv_offset = datafmt_1.lastcol-2;
    __RCB_dep_var_offset = (datafmt_1.lastcol-1)*4999;
    icount = 0;
    i_1 = wfile_1.nfile;
    for (j = 1; j <= i_1; ++j) {
	paramset_(&j, &x[1]);
	(*_RCB_initialize_parameters)(inread_1.par);
	i_2 = wfile_1.npoint[j - 1];
	for (i = 1; i <= i_2; ++i) {
	    (*_RCB_theory)(icount);
	    fitting_1.cv[icount] = __RCB_cv[icount][__RCB_cv_offset];
	    extra_1.f[icount] = (*_RCB_residual)(icount);
	    fvec[icount+1] = extra_1.f[icount];
	    extra_1.g[icount] = extra_1.f[icount];
	    ++icount;
	}
    }
    return 0;
} /* usrfun_ */


void
two_column_data_theory (int index)
{
    __RCB_cv[index][__RCB_cv_offset] = (*_RCB_tcd_y_value)(&print_1.data[index]);
}
double
two_column_data_residual (int index)
{
    __RCB_res[index][__RCB_cv_offset] = print_1.data[index+__RCB_dep_var_offset] - 
	                                __RCB_cv[index][__RCB_cv_offset];
    return (__RCB_res[index][__RCB_cv_offset]);
}
double
two_column_data_residual_custom (int index)
{
    __RCB_res[index][__RCB_cv_offset] = (*_RCB_forward)(&(print_1.data[index+__RCB_dep_var_offset]),
							&(__RCB_cv[index][__RCB_cv_offset]));
    return (__RCB_res[index][__RCB_cv_offset]);
}
double
two_column_data_residual_outdated (int index)
{
    __RCB_res[index][__RCB_cv_offset] = (*_RCB_tcd_residual)(&print_1.data[index],
							     &print_1.data[index+__RCB_dep_var_offset]);
    return (__RCB_res[index][__RCB_cv_offset]);
}

void
multi_column_data_theory (int index)
{
    static double  T[11], x;
    int            i, kk, nvar;

    x = print_1.data[index];
    (*_RCB_mcd_y_value)(&x, T);
    
    for (kk=0 ; kk<=__RCB_cv_offset ; kk++) 
    {
	__RCB_cv[index][kk] = T[kk+1];
    }
}
double
multi_column_data_residual (int index)
{
    static double  dr, total_residual;
    int            i, kk;

    total_residual = 0.0;
    for (i=index+4999,kk=0 ; kk<=__RCB_cv_offset ; kk++,i+=4999)
    {
	dr = __RCB_res[index][kk] = print_1.data[i] - __RCB_cv[index][kk];
	total_residual += (dr*dr);
    }
    return (sqrt(total_residual));
}
double
multi_column_data_residual_custom (int index)
{
    static double  dr, total_residual;
    int            i, kk;

    total_residual = 0.0;
    for (i=index+4999,kk=0 ; kk<=__RCB_cv_offset ; kk++,i+=4999)
    {
	dr = __RCB_res[index][kk] = (*_RCB_forward)(&(print_1.data[i]), &(__RCB_cv[index][kk]));
	total_residual += (dr*dr);
    }
    return (sqrt(total_residual));
}
double
multi_column_data_residual_outdated (int index)
{
    static double  data_vector[11], R[11], total_residual;
    int            i, kk, nvar;

    nvar = datafmt_1.lastcol;
    for (i=index,kk=1 ; kk<=nvar ; kk++,i+=4999)
	data_vector[kk-1] = print_1.data[i];

    total_residual = (*_RCB_mcd_residual)(data_vector, R);
    
    for (i=index+4999,kk=0 ; kk<__RCB_cv_offset ; kk++,i+=4999) 
    {
	__RCB_res[index][kk] = R[kk+1];
    }
    return (total_residual);
}
