#ifndef __RCB__H__
#define __RCB__H__


#define  __RCBdatasize  49990  /*  extended to 10 columns, was [4999][4] in original */

double   **__RCB_cv, **__RCB_res;
double   **__RCBsim_cv_depot, **__RCBsim_res_depot, **__RCBsim_data_depot;

double     __RCB_randmax;

/* Common Block Declarations */

union {
    struct {
	integer m, n, nfix, ifree[99], ifixed[99], npos, ipos[99];
    } _1;
    struct {
	integer numpts, n, nfix, ifree[99], ifixed[99], npos, ipos[99];
    } _2;
    struct {
	integer numpnt, n, nfix, ifree[99], ifixed[99], npos, ipos[99];
    } _3;
} mandn_;

#define mandn_1 (mandn_._1)
#define mandn_2 (mandn_._2)
#define mandn_3 (mandn_._3)

struct {
    doublereal data[__RCBdatasize]	/* was [4999][4] */, guess[99], rconst[99];
    integer iconst[99];
} print_;

#define print_1 print_

union {
    struct {
	integer lastcol, isame, jsame[99];
    } _1;
    struct {
	integer nvar, isame, jsame[99];
    } _2;
} datafmt_;

#define datafmt_1 (datafmt_._1)
#define datafmt_2 (datafmt_._2)

struct {
    integer numfile, idatapts[99];
} datafile_;

#define datafile_1 datafile_

struct {
    doublereal par[99];
    char pname[693];
} inread_;

#define inread_1 inread_

struct {
    doublereal parval[9801]	/* was [99][99] */;
    char parname[68607]	/* was [99][99] */;
} parstuff_;

#define parstuff_1 parstuff_

struct {
    integer frcnt, ficnt, frarr[99], fiarr[99];
} cntpar_;

#define cntpar_1 cntpar_

struct {
    integer jacopt, sepopt;
} option2_;

#define option2_1 option2_

struct {
    integer nfile, npoint[99];
} wfile_;

#define wfile_1 wfile_

struct {
    integer dset;
} neces1_;

#define neces1_1 neces1_

struct {
    doublereal xdata[4999], ydata[4999], tdata[__RCBdatasize]	/* was [4999][4] */;
} neces2_;

#define neces2_1 neces2_

struct {
    doublereal f[4999], g[4999];
} extra_;

#define extra_1 extra_

struct {
    doublereal cv[4999];
} fitting_;

#define fitting_1 fitting_

struct {
    integer noption, poption, coption, pubqual, conint, rsimopt;
} option1_;

#define option1_1 option1_

struct {
    integer numsim, simprint, noisetp;
} simstuff_;

#define simstuff_1 simstuff_

struct {
    doublereal ftol, xtol, gtol, x[99];
    integer maxfev;
} clams_;

#define clams_1 clams_

struct {
    char tstring[64], xstring[64], ystring[64];
    doublereal theight, lheight;
} titles_;

#define titles_1 titles_

struct {
    real xleft[99], xstep[99], xright[99];
} xplot_;

#define xplot_1 xplot_

struct {
    real ybot[99], ystep[99], ytop[99];
} yplot_;

#define yplot_1 yplot_

struct {
    integer ivopt;
    real ivmin, ivstp, ivmax, ivpts;
} indepvar_;

#define indepvar_1 indepvar_

struct {
    integer lfreeopt, lfixopt;
    doublereal values[99];
} legend_;

#define legend_1 legend_

struct {
    integer ipos2[99];
} postwo_;

#define postwo_1 postwo_

struct {
    doublereal frpar[9801]	/* was [99][99] */;
} fpar_;

#define fpar_1 fpar_

struct {
    integer finpos[99], finnpos;
} positive_;

#define positive_1 positive_

union {
    struct {
	char rname[693], iname[693], xname[693];
    } _1;
    struct {
	char drname[693], diname[693], dxname[693];
    } _2;
} names_;

#define names_1 (names_._1)
#define names_2 (names_._2)

struct {
    integer dcount;
} z_;

#define z_1 z_

struct {
    integer scount;
} z5_;

#define z5_1 z5_

struct {
    real xorig, xstp, xmax, yorig, ystp, ymax;
} plotting_;

#define plotting_1 plotting_

struct {
    integer infoz[99], ipars[297]	/* was [99][3] */;
    doublereal ssqz[495]	/* was [99][5] */;
} z2_;

#define z2_1 z2_

struct {
    doublereal dataz[4999], cvz[4999], fz[4999];
} z3_;

#define z3_1 z3_

struct {
    doublereal fitres[4999];
} bsnoise_;

#define bsnoise_1 bsnoise_

struct {
    logical delsims[4999];
    integer simcount;
} simparms_;

#define simparms_1 simparms_

struct {
    doublereal confidl[99], confidu[99];
} stats_;

#define stats_1 stats_

struct {
    char rzname[68607]	/* was [99][99] */, xzname[68607]	/* was [99][
	    99] */;
} znames_;

#define znames_1 znames_

struct {
    doublereal zguess[9801]	/* was [99][99] */, zx[9801]	/* was [99][
	    99] */, rzconst[9801]	/* was [99][99] */;
} z1_;

#define z1_1 z1_

struct {
    doublereal sqrt2;
} const_;

#define const_1 const_

struct {
    doublereal moment1, stddev, rannum;
} fpass_;

#define fpass_1 fpass_

/* Table of constant values */

static integer c__3 = 3;
static integer c__1 = 1;
static integer c__5 = 5;
static integer c__4 = 4;
static integer c__9 = 9;
static integer c__0 = 0;
static doublereal c_b502 = 0.0;
static doublereal c_b520 = 10.;
static real c_b592 = (float)0.;
static integer c__19 = 19;
static integer c__2 = 2;
static real c_b689 = (float).5;
static real c_b707 = (float)1.;
static real c_b736 = (float).2;
static real c_b737 = (float).82;
static real c_b740 = (float).17;
static real c_b741 = (float).67;
static integer c__7 = 7;
static real c_b747 = (float).08;
static real c_b751 = (float).03;
static integer c__12 = 12;
static integer c__6 = 6;
static real c_b757 = (float)-.11;
static real c_b758 = (float)-.015;
static real c_b773 = (float).015;
static real c_b812 = (float).75;

#endif
