#include <stdio.h>
#include <stdlib.h>
#include "RCBfit.h"

int
main (int argc, char *argv[])
{
    void    inip_(double*);
    double  fun_(double*);
    
    if (argc>=4 || argc==2) 
    {
	fprintf (stderr,"Wrong number of arguments: %d\n", argc);
	exit(1);
    }
    else
    {
	if (argc==1) 
	    RCBfit ("fittp", inip_, fun_);
	if (argc==3)
	{
	    if (strcmp(argv[1],"-fit")==0)
	    {
		fprintf (stderr, "Calling fit program with tapefile \"%s\"...\n", argv[2]);
		RCBfit (argv[2], inip_, fun_);
	    }
	    else if (strcmp(argv[1],"-guess")==0)
		rcb_guess (argv[2], inip_, fun_);
	    else 
		fprintf (stderr, "Unknown option: %s\n", argv[1]);
	}
	exit(0);
    }
}


