/*********************************
 *
 *      FUI header comments
 *
 *  FitDataFormat:    TwoColumn  
 *
 *********************************/
#include <math.h>


double   theta, sigma;

void
initialize (double *parameters)
{
/*
    Begin: Synonyms

    theta        threshold           th
    sigma        scale_factor         s

    End: Synonyms
*/
    theta = parameters[0];
    sigma = parameters[1];
}
double
value (double *t)  {  return (sigma*(*t)/(*t+theta));  }

void
prn_data (int *data_idx, int *var_idx, double *exp_val, double *cal_val, double *c)
{
    c[0] = *exp_val/sigma;
    c[1] = *cal_val/sigma;
}
