#!/usr/bin/perl

srand($ARGV[0]);
&noise_amplitude (0.2);

$f1  = 50.0;
$xp1 = 0.1;
$f2  = 0.5;
$xp2 = 0.01;

$t_switch =  40.0;
$t_step   =   3.0;
$t_final  = 200.0;
for ($t=0.02 ; $t<=$t_final ; $t+=$t_step)  {
    $t_step = 0.5  if ($t>$t_switch);
    $y = $f1*exp(-$xp1*$t) + $f2*exp(-$xp2*$t);
    printf ("%e %e\n", $t, $y*($cno+$dno*rand));
}

sub noise_amplitude {
    local($no) = @_;

    $cno = 1.0-$no;
    $dno = 2.0*$no;
}
