#include <stdlib.h>
#include <stdio.h>
#include "RCBfit.h"


int
main (int argc, char *argv[])
{
    void    initialize(double*);
    double  function(double*,double*);
    
    if (argc>4 || argc==2) 
    {
	fprintf (stderr,"Wrong number of arguments.\n");
	exit(1);
    }
    else
    {
	/*************  put switches here *************/
	/**********************************************/
	if (argc==1) 
	    RCBfit ("fittp", initialize, function);
	else
	{
	    if (strcmp(argv[1],"-fit")==0)
		RCBfit (argv[2], initialize, function);
	    else if (strcmp(argv[1],"-guess")==0)
		rcb_guess (argv[2], initialize, function);
	    else 
	    {
		fprintf (stderr, "Unknown option: %s\n", argv[1]);
		exit(1);
	    }
	}
	exit(0);
    }
}
