#ifndef __RCBfit__H__
#define __RCBfit__H__

enum  __RCB__DATA_STYLES__  
{   _RCB_TWO_COLUMN,  _RCB_MULTI_COLUMN  };

/* 
   active procedures 
*/
void  RCBfit(char*, void(*)(double*), double(*)());
void  rcb_guess(char*, void(*)(double*), double(*)());

void  rcb_fit(char*, void(*)(double*), double(*)(), double(*)()); /* compatibility with old code */

/*
   switch procedures
*/
void  rcb_select_data_style(int);
void  rcb_set_customized_data_output(void(*)(int*,int*,double*,double*,double*));
void  rcb_set_customized_distance_measure(double(*)(double*,double*),double(*)(double*,double*));

#endif
